unit mudrak;

interface

uses Testu,crt;

function tah(px,py,r,tob,bto,zr:integer):integer;
procedure initvar;

implementation

type maska = array [1..4,1..2] of integer;

const sirka:array[1..7,1..4] of integer=
      ((2,2,2,2),(4,1,4,1),(3,2,3,2),(3,2,3,2),(3,2,3,2),(3,2,3,2),(3,2,3,2));

      vyska:array[1..7,1..4,1..2] of integer=(
      ((0,0),(0,0),(0,0),(0,0)),((0,0),(0,0),(0,0),(0,0)),
      ((1,1),(1,0),(0,0),(0,1)),((1,0),(0,0),(0,0),(0,2)),
      ((0,1),(2,0),(0,0),(0,0)),((1,0),(0,1),(1,0),(0,1)),
      ((0,1),(1,0),(0,1),(1,0)));

      masky:array[1..7,1..4] of maska=(
      (((0,0),(1,1),(0,1),(1,0)),((0,0),(1,1),(0,1),(1,0)),  {strvorec}
       ((0,0),(1,1),(0,1),(1,0)),((0,0),(1,1),(0,1),(1,0))),

      (((0,0),(1,0),(2,0),(3,0)),((0,0),(0,1),(0,2),(0,3)),  {palicka}
       ((0,0),(1,0),(2,0),(3,0)),((0,0),(0,1),(0,2),(0,3))),

      (((0,1),(1,0),(1,1),(2,1)),((0,1),(1,0),(1,1),(1,2)),
       ((0,0),(1,0),(1,1),(2,0)),((0,0),(0,1),(0,2),(1,1))),

       (((0,1),(1,1),(2,0),(2,1)),((0,0),(1,0),(1,1),(1,2)),
       ((0,0),(0,1),(1,0),(2,0)),((0,0),(0,1),(0,2),(1,2))),

      (((0,0),(0,1),(1,1),(2,1)),((0,2),(1,0),(1,1),(1,2)),
       ((0,0),(1,0),(2,0),(2,1)),((0,0),(0,1),(0,2),(1,0))),

      (((1,0),(2,0),(0,1),(1,1)),((0,0),(0,1),(1,1),(1,2)),
       ((1,0),(2,0),(0,1),(1,1)),((0,0),(0,1),(1,1),(1,2))),

      (((0,0),(1,0),(1,1),(2,1)),((1,0),(0,1),(1,1),(0,2)),
       ((0,0),(1,0),(1,1),(2,1)),((1,0),(0,1),(1,1),(0,2)))
     );
     hranica:array[1..7,1..4]of maska=(
      (((0,1),(1,1),(0,1),(1,1)),((0,1),(1,1),(0,1),(1,1)),
       ((0,1),(1,1),(0,1),(1,1)),((0,1),(1,1),(0,1),(1,1))),

      (((0,0),(1,0),(2,0),(3,0)),((0,3),(0,3),(0,3),(0,3)),
       ((0,0),(1,0),(2,0),(3,0)),((0,3),(0,3),(0,3),(0,3))),

      (((0,1),(1,1),(2,1),(2,1)),((0,1),(1,2),(1,2),(1,2)),
       ((0,0),(1,1),(2,0),(2,0)),((0,2),(1,1),(0,2),(1,1))),

      (((0,1),(1,1),(2,1),(2,1)),((0,0),(1,2),(1,2),(1,2)),
       ((0,1),(1,0),(2,0),(2,0)),((0,2),(1,2),(0,2),(1,2))),

      (((0,1),(1,1),(2,1),(2,1)),((0,2),(1,2),(1,2),(1,2)),
       ((0,0),(1,0),(2,1),(2,1)),((0,2),(1,0),(0,2),(1,0))),

      (((1,1),(2,0),(0,1),(1,1)),((0,1),(1,2),(1,2),(1,2)),
       ((1,1),(2,0),(0,1),(1,1)),((0,1),(1,2),(1,2),(1,2))),

      (((0,0),(1,1),(2,1),(2,1)),((1,1),(0,2),(1,1),(0,2)),
       ((0,0),(1,1),(2,1),(2,1)),((1,1),(0,2),(1,1),(0,2)))
      );

var pole   : array [0..c1+1,1..c2+1] of boolean;
    stlpec : array [0..c1+1] of 0..c2;          { y-ova sur. najvyssej
                                                kocky v stlpcoch }
    x,ymin,rot  : integer;
    hotovo : boolean;     { ulozili sme ho do pola ??? }

function maxstl:integer;
var i,max:integer;
begin
  max:=c2;
  for i:=1 to c1 do
    if stlpec[i]<max then max:=stlpec[i];
  maxstl:=max;
end;

procedure initvar;
var i,j: integer;
begin
  for i:=1 to c2 do
    for j:=1 to c1 do pole[j,i]:=false;
  for i:=1 to c2 do begin
    pole[0,c2]:=true; pole[c1+1,c2]:=true
  end;
  for i:=0 to c1+1 do pole[i,c2+1]:=true;
  for i:=1 to c1 do stlpec[i]:=c2;
  hotovo:=true;
end;

function padni(tvar, rot, x, y : integer): integer;
var i    : integer;
    flag : boolean;                                 { y==vrch }
begin
  flag:=true;
  while flag do begin
    inc(y);
    if x+sirka[tvar,rot]>16 then begin padni:=0; exit end
    else
      for i:=1 to 4 do
        if stlpec[x+masky[tvar,rot,i,1]]<=y+masky[tvar,rot,i,2] then
          flag:=false;
  end;
  padni:=y-1
end;

function sedi(tvar, rot, x, y:integer): boolean;
var i:integer;
    flag:boolean;
begin
  flag:=true;
  for i:=1 to sirka[tvar,rot] do
    if stlpec[x+hranica[tvar,rot,i,1]]>(y+1+hranica[tvar,rot,i,2]) then
      flag:=false;
  sedi:=flag
end;


function jama:integer;
var i,j,x1,y,hmax,h1,xmax:integer;
begin
  x:=0;

  hmax:=0; y:=0; xmax:=0; x1:=0; h1:=0;
  for i:=1 to c1 do begin
    j:=stlpec[i]-stlpec[i-1];
    if stlpec[i]-stlpec[i+1]<j then j:=stlpec[i]-stlpec[i+1];

    if ((stlpec[i]>y) and ((j>2) or (hmax<4))) or
       ((stlpec[i]=y) and (j>h1)) then begin
      x1:=i; y:=stlpec[i]; h1:=j
    end;
    if (j>hmax) then begin
      hmax:=j; xmax:=i
    end
  end;

  rot:=2;
  if (hmax<2) and (h1<2) then jama:=0
  else if (x1>0) then begin x:=x1; jama:=y-4 end
  else if (xmax>0) then begin x:=xmax; jama:=stlpec[xmax]-4 end
  else jama:=0
end;

function tah(px,py,r,tob,bto,zr:integer):integer;
var y,y2,x2,r2,i,j,s,smax,k,p,pmax:integer;
    sadol : boolean;
    vrch  : integer;                           {najvyssie padnuta kocka }
begin

  if (py=2) and hotovo then begin
    y:=1; sadol:=false; ymin:=1; y2:=1; smax:=0; pmax:=100;
    hotovo:=false;
    if zr>0 then for i:=1 to c1 do begin
      y:=stlpec[i]+zr;
      repeat inc(y) until test(i,y); dec(y);
      stlpec[i]:=y
    end;
    stlpec[0]:=stlpec[2]; stlpec[c1+1]:=stlpec[c1-1];

    if (tob=2) then begin
      ymin:=jama;
      if ymin>0 then begin
        tah:=2; exit
      end
    end;
    vrch:=maxstl-3;
    for i:=1 to c1 do
      for j:=1 to 4 do begin
        y:=padni(tob,j,i,vrch);
        if (y>y2) then begin
          y2:=y; x2:=i; r2:=j
        end;
        if sedi(tob,j,i,y) then begin
          s:=0;
          for k:=1 to 4 do s:=s+masky[tob,j,k,2]+y;
          p:=0;
          if (i=2) then p:=stlpec[1]-(y+vyska[tob,j,1]);
          if i>2 then
            p:=stlpec[i-1]-stlpec[i-2]+stlpec[i-1]-(y+vyska[tob,j,1]);
          if (i=14) then p:=p+stlpec[15]-(y+vyska[tob,j,2]);
          if i<14 then
            p:=p+stlpec[i+1]-stlpec[i+2]+stlpec[i+1]-(y+vyska[tob,j,2]);
          if (s>smax) or ((s=smax) and (p<pmax)) then begin
            sadol:=true; smax:=s; ymin:=y; x:=i; rot:=j; pmax:=p
          end
        end;
      if (tob=1) then j:=4;
      if ((tob=6) or (tob=7) or (tob=2)) and (j=2) then j:=j+2;
      end;
    if (sadol and (y2>ymin+1)) or sadol=false then begin   { y2<ymin+4 }
      x:=x2; rot:=r2; ymin:=y2;
    end
  end;
  if r<>rot then begin tah:=2; exit end;
  if px<x then begin tah:=3; exit end;
  if px>x then begin tah:=1; exit end;

  if not hotovo then begin
    for i:=1 to 4 do
      if stlpec[px+masky[tob,r,i,1]]>ymin+masky[tob,r,i,2] then
        stlpec[masky[tob,r,i,1]+px]:=masky[tob,r,i,2]+ymin;
    hotovo:=true
  end;
  { zmen pole stlpec. ale co ak nebudeme mat cas ?? }
  tah:=4
end;
end.