program tetris;

uses graph,crt,dos,mudraks,Testu;

const pt=7;

type pole=array[1..pt,1..4]of integer;
     maska=array[1..4,1..2]of integer;
     zaznam=record
             meno:string[30];
             skore:integer
            end;

const patt:fillpatterntype=($ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff);
      vzor:fillpatterntype=($99,$3c,$66,$c3,$c3,$66,$3c,$99);

      c0=40;
      cx=8;cy=9*cx div 11;cz=5*cx div 11;

      cxz=cx div 3;c350=200;c50=4*cx+6*cx div 11;c39=4*cy+cxz;

      px:pole=((0,0,0,0),(-1,1,-2,2),(-1,0,0,1),
      (-1,0,0,1),(-1,0,0,1),(0,1,-1,0),(0,1,-1,0));
      py:pole=((1,1,1,1),(2,-1,3,0),(1,1,2,0),
      (1,1,2,0),(1,1,2,0),(2,0,1,1),(2,0,1,1));

      masky:array[1..pt,1..4]of maska=(
      (((0,0),(1,0),(0,1),(1,1)),((0,0),(1,0),(0,1),(1,1)),
       ((0,0),(1,0),(0,1),(1,1)),((0,0),(1,0),(0,1),(1,1))),

      (((0,0),(1,0),(2,0),(3,0)),((0,0),(0,1),(0,2),(0,3)),
       ((0,0),(1,0),(2,0),(3,0)),((0,0),(0,1),(0,2),(0,3))),

      (((0,1),(1,0),(1,1),(2,1)),((0,1),(1,0),(1,1),(1,2)),
       ((0,0),(1,0),(1,1),(2,0)),((0,0),(0,1),(0,2),(1,1))),

       (((0,1),(1,1),(2,0),(2,1)),((0,0),(1,0),(1,1),(1,2)),
       ((0,0),(0,1),(1,0),(2,0)),((0,0),(0,1),(0,2),(1,2))),

      (((0,0),(0,1),(1,1),(2,1)),((0,2),(1,0),(1,1),(1,2)),
       ((0,0),(1,0),(2,0),(2,1)),((0,0),(0,1),(0,2),(1,0))),

      (((1,0),(2,0),(0,1),(1,1)),((0,0),(0,1),(1,1),(1,2)),
       ((1,0),(2,0),(0,1),(1,1)),((0,0),(0,1),(1,1),(1,2))),

      (((0,0),(1,0),(1,1),(2,1)),((1,0),(0,1),(1,1),(0,2)),
       ((0,0),(1,0),(1,1),(2,1)),((1,0),(0,1),(1,1),(0,2)))
       );

      vlavo=false;vpravo=true;
      a=6;b=2;ctime=4;

      col1=3;
      col2=2;
      col3=1;
      col4=2;
      col5=2;
      col6=2;
      col7=2;

var gd,gm:integer;
    cub,pozad:pointer;obr:array[1..pt,1..4]of pointer;
    stenad,kon,praz:boolean;
    z:char;counts:string[7];
    obx,soby,oby,ox,oy,ot,op,i,dalsi,dellines,obt,iz,l,stoji:integer;
    count:longint;
    time1,timerez:real;
    tabulka:array[0..16]of zaznam;
    memtab:file of zaznam;
    rnd:text;
    S: PathStr;

function randomm:integer;
 var q:integer;
 begin
  q:=random(6);
  if q>0 then randomm:=q+1 else randomm:=q;
 end;

procedure rrandomize;
 begin
  randomize;
  assign(rnd,'random.dat');
   {$I-}
   reset(rnd);
   {$I+}
   if {ioresult<>0} true then
    begin
     rewrite(rnd);
     for i:=1 to 500 do writeln(rnd,random(7));
     close(rnd);reset(rnd);
    end;
 end;

function rrandom(n:integer):integer;
 var pom,err:integer;
     POM1:STRING;
 begin
  repeat
  if eof(rnd) then reset(rnd);
  readln(rnd,pom1);
  val(pom1,pom,err);
  until err=0;
  rrandom:=pom mod n;
 end;

procedure uvod;
 var size,size1,c,mx,my:integer;z:char;poms:string[20];
 begin
  setbkcolor(1);
  setfillpattern(patt,col1);
  setcolor(col2);
  bar3d(20,c350-cx,20+cx,c350-cx+cy,cz,topon);
  setfillpattern(patt,col3);
  floodfill(23,c350-cx-1,col2);
  floodfill(20+cx+1,c350-cx,col2);
  size:=imagesize(20,c350-cx-cxz,20+16*cx div 11,c350-cx+cy);
  getmem(cub,size);
  getimage(20,c350-cx-cxz,
           20+16*cx div 11,c350-cx+cy,cub^);
  cleardevice;

  for ot:=1 to pt do
   for op:=1 to 4 do
    for c:=1 to 4 do
      putimage((op-1)*5*cx+masky[ot,op,c,1]*cx+cx,
               (ot-1)*5*cy+masky[ot,op,c,2]*cy,
               cub^,orput);


  for ot:=1 to pt do
   for op:=1 to 4 do
    begin
     mx:=0;my:=0;
     for c:=1 to 4 do
      begin
       if masky[ot,op,c,1]>mx then mx:=masky[ot,op,c,1];
       if masky[ot,op,c,2]>my then my:=masky[ot,op,c,2];
      end;
     mx:=mx*cx+16*cx div 11;
     my:=my*cy+cy+cxz;
     size:=imagesize((op-1)*5*cx,(ot-1)*5*cy,
                     (op-1)*5*cx+mx,(ot-1)*5*cy+my);
     getmem(obr[ot,op],size);
     getimage((op-1)*5*cx+cx,(ot-1)*5*cy,
              (op-1)*5*cx+mx+cx,(ot-1)*5*cy+my,obr[ot,op]^);
    end;

  settextstyle(defaultfont,horizdir,1);
  setcolor(col4);
  outtextxy(205,180,'Stlac klavesu!');
  while not keypressed do;z:=readkey;
 end;

procedure uvod2;
 begin
  setbkcolor(0);
  setcolor(col6);
  setfillpattern(patt,col3);
  bar3d(c0-17,cy+cxz,c0,(c2+2)*cy+cxz,cz,topon);
  bar3d(c0-17,(c2+2)*cy+cxz,
        c0+cx*(c1+2),(c2+2)*cy+cxz+17,cz,topoff);
  setcolor(col3);
  line(c0-16,(c2+2)*cy+cxz,c0-1,(c2+2)*cy+cxz);
  setfillpattern(patt,col2);
  floodfill(c0-14,cy+cxz-1,col6);
  for i:=1 to c2 do putimage(c0,i*cy,cub^,orput);
  for i:=1 to c1+2 do putimage(c0+(i-1)*cx,(c2+1)*cy,cub^,orput);
  for i:=1 to c2 do putimage(c0+(c1+1)*cx,i*cy,cub^,orput);

  setfillpattern(patt,col3);
  setcolor(col6);
  bar3d(c0+cx*(c1+2),cy+cxz,
        c0+cx*(c1+2)+17,(c2+2)*cy+cxz+17,cz,topon);
  setcolor(col3);
  line(c0+(c1+2)*cx,(c2+2)*cy+cxz+1,
       c0+(c1+2)*cx,(c2+2)*cy+cxz+16);
  setfillpattern(patt,col2);
  floodfill(c0+cx*(c1+2)+9,cy+cxz-1,col6);
  floodfill(c0+cx*(c1+2)+19,cy+cxz,col6);

  getmem(pozad,imagesize(0,0,c50,c39));

  count:=0;

   end;

function testobr(x,y:integer):boolean;
 var b:boolean;i:integer;
 begin
  b:=false;i:=0;
  repeat
   i:=i+1;
  until (i>4) or
        (getpixel(x+masky[ot,op,i,1]*cx+2,
         y+masky[ot,op,i,2]*cy+cxz+2)=3);
  testobr:=(i<=4);
 end;


procedure posuny;
 begin
  putimage(ox,oy,pozad^,copyput);
  if not testobr(ox,oy+cy) then
   begin
    getimage(ox,oy+cy,ox+c50,oy+cy+c39,pozad^);
    putimage(ox,oy+cy,obr[ot,op]^,orput);
    oy:=oy+cy;oby:=oby+1;stenad:=false;
   end
  else
   begin
    putimage(ox,oy,obr[ot,op]^,orput);
    stenad:=true;
   end;
  end;

procedure posunx(vpravo:boolean);
 var dx:integer;
 begin
  if vpravo then dx:=cx else dx:=-cx;
  putimage(ox,oy,pozad^,copyput);
  getimage(ox+dx,oy,ox+dx+c50,oy+c39,pozad^);
  putimage(ox+dx,oy,obr[ot,op]^,orput);
  ox:=ox+dx;obx:=obx+(dx div cx);
 end;

procedure posunxy(vpravo:boolean);
 var dx:integer;
 begin
  if vpravo then dx:=cx else dx:=-cx;
  putimage(ox,oy,pozad^,copyput);
  if not testobr(ox+dx,oy+cy) then
   begin
    getimage(ox+dx,oy+cy,ox+dx+c50,oy+cy+c39,pozad^);
    putimage(ox+dx,oy+cy,obr[ot,op]^,orput);
    ox:=ox+dx;oy:=oy+cy;obx:=obx+dx div cx;oby:=oby+1
   end
  else if testobr(ox+dx,oy) then posuny
   else posunx(vpravo);
 end;

procedure vytvor(x,y:integer);
 begin
  getimage(x,y,x+c50,y+c39,pozad^);
  if not testobr(x,y) then
   begin
    putimage(x,y,obr[ot,op]^,orput);
    ox:=x;oy:=y;obx:=(x-c0) div cx;oby:=y div cy;
   end
  else stenad:=true;
 end;

procedure otoc;
 begin
  op:=op+1;if op=5 then op:=1;
  putimage(ox,oy,pozad^,copyput);
  vytvor(ox+px[ot,op]*cx,oy+py[ot,op]*cy);
  if stenad then
   begin
    op:=op-1;if op=0 then op:=4;
    getimage(ox,oy,ox+c50,oy+c39,pozad^);
    posuny;
   end;
 end;

procedure space;
 begin
  putimage(ox,oy,pozad^,copyput);
  while not testobr(ox,oy+cy) do oy:=oy+cy;
  putimage(ox,oy,obr[ot,op]^,orput);
  stenad:=true;
 end;

function key:char;
 var z:char;
 begin
  if not keypressed then key:='.'
  else
   begin
    key:=readkey;
    while keypressed do z:=readkey;
   end
 end;

function riadok(n:integer):boolean;
 var b,f:boolean;i,j:integer;
 begin
  n:=(c2+1-n)*cy+cxz;
  b:=true;praz:=true;
  for i:=1 to c1 do
   begin
    f:=(getpixel(c0+cx*i+2,n+2)=3);
    if b then b:=f;
    if praz then praz:=not f;
    if not f then
     if (getpixel(c0+cx*i+2,n+2+cy)<3) and
        (getpixel(c0+cx*i+3+6*cx div 11,n+cy-1)=col3) then
      begin
       setfillpattern(vzor,8);
       for j:=1 to cxz+1 do
        bar(c0+cx*i+j,n+cy+1-j,c0+(i+1)*cx-1+j,n+cy+1-j);
       if getpixel(c0+cx*i+cx+2,n+2)=3 then
        putimage(c0+cx*i+cx,n-cxz,cub^,orput);
        if getpixel(c0+cx*i-cx+2,n+cy+2)=3 then
         putimage(c0-cx+cx*i,n+cy-cxz,cub^,orput);
      end;
   end;
  riadok:=b;
 end;

procedure zmaz(n:integer);
 var loc:pointer;
 begin
  count:=count+2*c1;
  n:=(c2-n+1)*cy;
  getmem(loc,imagesize(c0+11,cy,c0+cx*(c1+1),n));
  getimage(c0+cx,cy+cxz,c0+cx*(c1+1),n+cxz,loc^);
  putimage(c0+cx,2*cy+cxz,loc^,copyput);
  freemem(loc,imagesize(c0+11,cy,c0+cx*(c1+1),n));
  case random(3) of
   0:setbkcolor(0);
   1:setbkcolor(1);
   2:setbkcolor(1);
  end;
 end;

function time:real;
 var h,m,s,st:word;
 begin
  gettime(h,m,s,st);
  time:=h*3600+m*60+s+st/100;
 end;

procedure novtab;
 var i:integer;
 begin
  for i:=1 to 15 do
   with tabulka[i] do
    begin
     meno:='..............................';
     skore:=0;
    end;
 end;

procedure cittab;
 var i:integer;
 begin
  reset(memtab);
  for i:=1 to 15 do
   read(memtab,tabulka[i]);
  close(memtab);
 end;

procedure zapistab;
 var i:integer;
 begin
  i:=15;
  repeat
   tabulka[i+1]:=tabulka[i]; i:=i-1;
  until (i=0) or (count<=tabulka[i].skore);
  i:=i+1; tabulka[i].skore:=count;
  window(8,4,74,22);textbackground(black);clrscr;
  writeln('NAPIS SVOJE MENO !');
  readln(tabulka[i].meno);
  while length(tabulka[i].meno)<30 do
   tabulka[i].meno:=tabulka[i].meno+'.';
  rewrite(memtab);
  for i:=1 to 15 do write(memtab,tabulka[i]);
  close(memtab);
 end;

begin
  gd:=cga;gm:=cgac3;rrandomize;
  initgraph(gd,gm,'c:\tp5');
  dellines:=0;
  uvod;
  closegraph;
  assign(memtab,'memtab.dat');
  repeat;
   {$I-}
   reset(memtab);
   {$I+}
   if ioresult<>0 then novtab else begin close(memtab); cittab end;
   tabulka[0].skore:=0;
   initgraph(gd,gm,'c:\tp5');
   uvod2;initvar;
   kon:=false;
   dalsi:=rrandom(pt)+1;
   timerez:=2.0;stoji:=0;
   while not kon do
    begin
     ot:=dalsi;op:=1;
     dalsi:=rrandom(pt)+1;
     stenad:=false;
     vytvor(c0+cx*(c1 div 2),2*cy);
     soby:=oby;
     count:=count+4;
     if stenad then kon:=true;
     while not stenad do
      begin
        setcolor(0);
        for l:=0 to 16 do line(250,20+l,300,20+l);
        setcolor(2);
        str(count,counts);
        outtextxy(250,20,counts);
        str(round(1000*timerez),counts);
        outtextxy(250,28,counts);
        time1:=time;
        if timerez<0 then
         begin
          iz:=0;
          timerez:=timerez+ctime/(1000+count)
         end
        else
         begin
          iz:=tah(obx,oby,op,ot,dalsi,dellines);
          timerez:=timerez+ctime/(1000+count)+time1-time;
         end;
        case iz of
         0:posuny;
         1:posunxy(vlavo);
         2:otoc;
         3:posunxy(vpravo);
         4:begin timerez:=timerez+(c2-oby)*ctime/(1000+count);space end;
         else posuny;
        end;i:=1;
        if oby=soby then stoji:=stoji+1
        else begin stoji:=0;soby:=oby end;
        if stoji>20 then stenad:=true;
      end;
     dellines:=0;
     repeat
      if riadok(i) then begin dellines:=dellines+1;zmaz(i) end
      else i:=i+1;
     until praz;
    end;
   setcolor(0);
   for l:=0 to 16 do line(250,20+l,300,20+l);
   setcolor(blue);
   str(count,counts);
   outtextxy(250,20,counts);
   str(round(1000*timerez),counts);
   outtextxy(250,28,counts);
   for i:=3 downto 0 do
    begin
     setbkcolor(i);delay(150);
    end;
   bar(14,170,140,197);
   outtextxy(20,180,'Stlac klavesu!');
   while keypressed do z:=readkey;
   while not keypressed do;
   while keypressed do z:=readkey;
   closegraph;
   if count>tabulka[15].skore then zapistab;
   textbackground(black);
   clrscr;window(3,1,79,24);textbackground(red);clrscr;
   window(8,2,74,23);textbackground(blue);clrscr;textcolor(10);
   writeln;writeln('TABULKA:':35);writeln;writeln;textcolor(4);
   writeln(1:6,'.',tabulka[1].meno:31,tabulka[1].skore:20);textcolor(2);
   for i:=2 to 15 do writeln(i:6,'.',tabulka[i].meno:31,tabulka[i].skore:20);
   writeln;textcolor(3);
   write('CHCES ESTE RAZ?(A/N)':35);z:=readkey;
  until not (z='a');
end.