unit miso;

interface

 uses TestU;

  function tah(px,py,r,tob,bty,zr:integer):integer;
  procedure initvar;

implementation

 var Gpos,Grot,Gnato:integer;
     neurcene:boolean;
     vyska:array[0..16]of integer;

 const
   maxlongint=2147483647;

   sir:array[1..7,1..4] of integer=
     ((2,2,2,2),(4,1,4,1),(3,2,3,2),(3,2,3,2),(3,2,3,2),(3,2,3,2),(3,2,3,2)
     );

   pocrot:array[1..7] of integer=
     (1,2,4,4,4,2,2
     );

   vys:array[1..7,1..4,1..4] of integer=
     (((2,2,0,0),(2,2,0,0),(2,2,0,0),(2,2,0,0)
      ),
      ((1,1,1,1),(4,0,0,0),(1,1,1,1),(4,0,0,0)
      ),
      ( (1,2,1,0),(2,3,0,0),(2,2,2,0),(3,2,0,0)
      ),
      ( (1,1,2,0),(3,3,0,0),(2,2,2,0),(3,1,0,0)
      ),
      ( (2,1,1,0),(1,3,0,0),(2,2,2,0),(3,3,0,0)
      ),
      ( (1,2,2,0),(3,2,0,0),(1,2,2,0),(3,2,0,0)
      ),
      ((2,2,1,0),(2,3,0,0),(2,2,1,0),(2,3,0,0)
      )
     );

  function vaha(vys:integer):longint;
  begin
   vaha:= 1000-1000 div (vys+1);
  end;

  procedure treskni(tob,rotacia,ps:integer;var nato:integer;var delta:longint);
   var horna_uroven,i,pp:integer;
       pom:integer;
  begin
    horna_uroven:=vyska[ps]+vys[tob,((rotacia+1) and 3 + 1),sir[tob,rotacia]];
    for i:=1 to sir[tob,rotacia]-1 do
      begin
        pom:=vyska[ps+i]-(horna_uroven-vys[tob,((rotacia+1) and 3 + 1),sir[tob,rotacia]-i]);
        if pom>0 then
            horna_uroven:=horna_uroven+pom;
      end;
    nato:=horna_uroven-sir[tob,((rotacia and 3)+1)];
    delta:=0;pp:=ps-1;
    for i:=1 to sir[tob,rotacia] do
     begin
      inc(pp);
      pom:=nato+vys[tob,rotacia,i];
      delta:=delta+(pom)*(pom)-
                   (vyska[pp])*(vyska[pp]);
     end;
  end;

  function tah(px,py,r,tob,bty,zr:integer):integer;
   var horna_uroven,pp,pom,i,y,nato,rotacia,ps,yy:integer;
       mindelta,delta:longint;
  begin
   if neurcene then
    begin
      if zr>0 then
        begin
          yy:=27+zr;
          for i:=1 to 15 do
            begin
             y:=yy-vyska[i];
             while not(test(i,y)) do inc(y);
             vyska[i]:=27-y;
            end;
        end;
      mindelta:=maxlongint;
      for rotacia:=1 to pocrot[tob] do
        for ps:=1 to 16-sir[tob,rotacia] do
         begin


{sem treskne}
{          treskni(tob,rotacia,ps,nato,delta);
 }
   begin
    horna_uroven:=vyska[ps]+vys[tob,((rotacia+1) and 3 + 1),sir[tob,rotacia]];
    for i:=1 to sir[tob,rotacia]-1 do
      begin
        pom:=vyska[ps+i]-(horna_uroven-vys[tob,((rotacia+1) and 3 + 1),sir[tob,rotacia]-i]);
        if pom>0 then
            horna_uroven:=horna_uroven+pom;
      end;
    nato:=horna_uroven-sir[tob,((rotacia and 3)+1)];
    delta:=0;pp:=ps-1;
    for i:=1 to sir[tob,rotacia] do
     begin
      inc(pp);
      pom:=nato+vys[tob,rotacia,i];
      delta:=delta+(pom)*(pom)-
                   (vyska[pp])*(vyska[pp]);
     end;
  end;



{tu uz netrieska}
          if delta<mindelta then begin
                                  Grot:=rotacia;
                                  Gpos:=ps;
                                  Gnato:=nato;
                                  mindelta:=delta;
                                 end
         end;
      neurcene:=false;
    end
   else if r<>Grot then tah:=2
   else if px<Gpos then tah:=3
   else if px>Gpos then tah:=1
   else begin
         tah:=4;
         for i:=Gpos to Gpos+sir[tob,r]-1 do
           vyska[i]:=Gnato+vys[tob,r,i-Gpos+1];
         neurcene:=true
        end;
  end;

 procedure initvar;
  var i:integer;
 begin
  for i:=1 to 15 do vyska[i]:=0;
  vyska[0]:=30;vyska[16]:=30;
  neurcene:=true;
 end;

begin
end.